# include 		"stdio.h"
# include		"dos.h"

# define COM   		0x2f8
# define STAT  		0x2fd
# define SEC2  		3
# define BUFF_SIZE 	128
# define CLK_TCK	18.2

void initialise();
void f_send();
void f_recv();

void main()
{
	int choice;

	initialise();
	do
	{
		clrscr();
		printf("\n\t*****MODE MENU*****\n\n");
		printf("\t1 - SEND FILE\n");
		printf("\t2 - RECEIVE FILE\n");
		printf("\t3 - QUIT\n");
		printf("\n\tENTER YOUR CHOICE\t: ");
		scanf("%d",&choice);
		switch(choice)
		{
		case 1:
			{
				f_send();
				break;
			}
		case 2:
			{
				f_recv();
				break;
			}
		case 3:
			{
				printf("\n\tBYE..BYE..BYE\n");
				printf("\n\tPRESS ANY KEY TO CONTINUE\n");
				getch();
				break;
			}
		}
	}while(choice!=3);
}


void initialise()
{
	union REGS inregs,outregs;

	inregs.h.al=0x83;
	inregs.h.ah=0;
	inregs.x.dx=1;
	int86(0x14,&inregs,&outregs);
}


void f_send()
{
	FILE *fp;
	int done,no_of_bytes,f_p;
	unsigned long f_end,curr_pos;
	char ch,f_name[20];

	printf("\n\tENTER THE FILE TO BE SENT\t: ");
	scanf("%s",f_name);
	if((fp=fopen(f_name,"rb"))==NULL)
	{
		printf("\n\tFILE COULDN'T BE OPENED\n");
		printf("\tPRESS ANY KEY TO CONTINUE\n");
		getch();
		exit(0);
	}
	done=0;
	f_p=0;
	fseek(fp,0,SEEK_END);
	f_end=ftell(fp);
	rewind(fp);
	curr_pos=0;
	no_of_bytes=0;
	while(!done)
	{
		ch=fgetc(fp);
		curr_pos++;
		if(curr_pos>f_end)
		{
			if(f_p)
				no_of_bytes=f_p;
			else
				no_of_bytes=-1;
			while(f_p < BUFF_SIZE)
			{
				while((inport(STAT)&0x20)==0);
				outport(COM,' ');
				delay(10);
				delay(5);
				f_p++;
				printf("%d  ",f_p);
			}
			done=1;
		}
		else
		{
			while((inport(STAT)&0x20)==0);
			outport(COM,ch);
			delay(10);
			delay(5);
			f_p++;
			printf("%d %x",f_p,ch);
		}
		if(f_p==BUFF_SIZE)
		{
			while((inport(STAT)&0x20)==0);
			outport(COM,no_of_bytes);
			delay(10);
			delay(5);
			printf("%d",no_of_bytes);
			f_p=0;
			printf("\n\tWRITE INTO FILE\n");
			sleep(SEC2);
		}
	}
	printf("\n\tFILE TRANSMITTED\n");
	printf("\n\tPRESS ANY KEY TO CONTINUE\n");
	fclose(fp);
	getch();
}


void f_recv()
{
	FILE *fp;
	int i,done,f_p,no_of_bytes;
	char f_name[20],buff[BUFF_SIZE],ch;

	printf("\n\tENTER THE FILE TO HOLD RECEIVED DATA\t: ");
	scanf("%s",f_name);
	if((fp=fopen(f_name,"wb"))==NULL)
	{
		printf("\n\tFILE COULDN'T BE OPENED\n");
		printf("\n\tPRESS ANY KEY TO CONTINUE\n");
		getch();
		exit(0);
	}
	fclose(fp);
	done=0;
	f_p=0;
	while(!done)
	{
		while((inport(STAT)&1)==0);
		buff[f_p]=inport(COM);
		f_p++;
		printf("%d %x",f_p,buff[f_p-1]);
		if(f_p==BUFF_SIZE)
		{
			while((inport(STAT)&1)==0);
			no_of_bytes=inport(COM);
			printf("%d",no_of_bytes);
			if(no_of_bytes)
			{
				done=1;
				f_p=no_of_bytes;
			}
			printf("\n\tWRITING INTO FILE\n");
			if(f_p<=BUFF_SIZE)
			{
				fp=fopen(f_name,"ab");
				for(i=0;i<f_p;i++)
					fprintf(fp,"%c",buff[i]);
				fclose(fp);
			}
			f_p=0;
		}
	}
	printf("\n\tFILE RECEIVED\n");
	printf("\n\tPRESS ANY KEY TO CONTINUE\n");
	getch();
}
